"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = jsxPragma;
var _pluginSyntaxJsx = _interopRequireDefault(require("next/dist/compiled/babel/plugin-syntax-jsx"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function jsxPragma({
  types: t
}) {
  return {
    inherits: _pluginSyntaxJsx.default,
    visitor: {
      JSXElement(_path, state) {
        state.set('jsx', true);
      },
      JSXFragment(_path, state) {
        state.set('jsx', true);
      },
      Program: {
        exit(path, state) {
          if (state.get('jsx')) {
            const pragma = t.identifier(state.opts.pragma);
            let importAs = pragma;
            const existingBinding = state.opts.reuseImport !== false && state.opts.importAs && path.scope.getBinding(state.opts.importAs);
            if (state.opts.property) {
              importAs = state.opts.importAs ? t.identifier(state.opts.importAs) : path.scope.generateUidIdentifier('pragma');
              const mapping = t.variableDeclaration('var', [t.variableDeclarator(pragma, t.memberExpression(importAs, t.identifier(state.opts.property)))]);
              let newPath;
              if (existingBinding && t.isVariableDeclarator(existingBinding.path.node) && t.isCallExpression(existingBinding.path.node.init) && t.isIdentifier(existingBinding.path.node.init.callee) && existingBinding.path.node.init.callee.name === 'require') {
                [newPath] = existingBinding.path.parentPath.insertAfter(mapping);
              } else {
                [newPath] = path.unshiftContainer('body', mapping);
              }
              for (const declar of newPath.get('declarations')) {
                path.scope.registerBinding(newPath.node.kind, declar);
              }
            }
            if (!existingBinding) {
              const importSpecifier = t.importDeclaration([state.opts.import ? t.importSpecifier(importAs, t.identifier(state.opts.import)) : state.opts.importNamespace ? t.importNamespaceSpecifier(importAs) : t.importDefaultSpecifier(importAs)], t.stringLiteral(state.opts.module || 'react'));
              const [newPath] = path.unshiftContainer('body', importSpecifier);
              for (const specifier of newPath.get('specifiers')) {
                path.scope.registerBinding('module', specifier);
              }
            }
          }
        }
      }
    }
  };
}