"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = NextPageDisallowReExportAllExports;
function NextPageDisallowReExportAllExports() {
  return {
    visitor: {
      ImportDeclaration(path) {
        if (['@next/font/local', '@next/font/google', 'next/font/local', 'next/font/google'].includes(path.node.source.value)) {
          const error = new SyntaxError(`"@next/font" requires SWC although Babel is being used due to a custom babel config being present.\nRead more: https://nextjs.org/docs/messages/babel-font-loader-conflict`);
          error.code = 'BABEL_PARSE_ERROR';
          error.loc = path.node.loc?.start ?? path.node.loc?.end ?? path.node.loc;
          throw error;
        }
      }
    }
  };
}