"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = NextPageDisallowReExportAllExports;
function NextPageDisallowReExportAllExports() {
  return {
    visitor: {
      ExportAllDeclaration(path) {
        const error = new SyntaxError(`Using \`export * from '...'\` in a page is disallowed. Please use \`export { default } from '...'\` instead.\n` + `Read more: https://nextjs.org/docs/messages/export-all-in-page`);
        error.code = 'BABEL_PARSE_ERROR';
        error.loc = path.node.loc?.start ?? path.node.loc?.end ?? path.node.loc;
        throw error;
      }
    }
  };
}